#!/usr/bin/env python
# coding=utf-8

from sys import argv
from random import randint
from types import ListType as List
from itertools import product

def filename(config, keylist):
	filnavn = prefix
	for key in keylist:
		filnavn += "-" + key + "_" + str(config[key])
	filnavn += postfix + ".sif"
	return filnavn

def dictinlist(settings):
	settingsList = []
	keylist = []
	for k, v in settings.iteritems():
		if type(v) == List:
			keylist.append(k)
	args = [ settings[k] for k in keylist ]
	prod = product(*args)
	while True:
		try:
			tmp2 = prod.next()
			tmp = dict(settings)
			for i,j in enumerate(tmp2):
				tmp[keylist[i]] = j
			settingsList.append(tmp)
		except StopIteration:
			break
	return (settingsList,keylist)

def makesif(configs):
	keylist = configs[1]
	configs = configs[0]
	for config in configs:
		sifstringre = sifstring
		for k, v in config.iteritems():
			sifstringre = sifstringre.replace(string+'seed',
					str(randint(0,1e10)))
			sifstringre = sifstringre.replace(string+'S',
					str(config['wavel']/config['S']))
			sifstringre = sifstringre.replace(string+'F',
					str(config['wavel']*config['F']))
			sifstringre = sifstringre.replace(string+'L',
					str(config['wavel']*config['F']*config['L']))
			sifstringre = sifstringre.replace(string+k, str(v))
		sifFile = filename(config,keylist)
		print sifFile
		sif = open(sifFile, "w")
		sif.write(sifstringre)
		sif.close()
		
string="placeholder"

prefix=""
postfix=""
if len(argv) == 1:
	exit()
if len(argv) >= 2:
	prefix = argv[1]
if len(argv) >=3:
	postfix = argv[2]

wavelength = 0.6127
t00 = -40
config = {
'wavel' : wavelength,
'yoff' : 30.0,
'N' : 10000,
'e1' : 1.01,
'e2' : 2.31,
'e3' : 1.01,
'pol' : 'p',
't0d' :  t00,
'ttd' : -t00,
'dTdt' : 1,
'seed' : randint(0,1e10),
'solver' : '!',
'S' : 5,
'F' : 10,
'L' : 10,
't0' : t00
}

zif = open("ossem.zif", "r")
sifstring = zif.read()
configs = dictinlist(config)
print "Producing", len(configs[0]), "files..."
makesif(configs)
print "Done"
