#!/usr/bin/python

from sys import argv as sifFiles
import time, os, datetime
import subprocess as subp
import multiprocessing as multip
from socket import gethostname

def maxwell_process(sifFile):
	cmd = list(maxwell)
	cmd[cmd.index("sifFile")] = sifFile
	cmd[cmd.index("ncFile")] = sifFile.replace("sif", "nc")
	logg = open(sifFile.replace("sif", "log"), "w")
	logg.write("Kommando: " + " ".join(cmd) +  "\n")
	logg.write("Dato: " + time.strftime("%d/%m/%Y %X") + "\n")
	print "Starter simulering for", sifFile, "paa", hostname
	tid = time.time()
	process = subp.Popen(cmd)
	process.wait()
	tid = time.time() - tid
	logg.write("Ekte tid: " + str(datetime.timedelta(seconds=tid)))
	logg.close()
	print "Ferdig med", sifFile
	
sifFiles.pop(0) # Fjerner navnet paa programmet selv
os.nice(19)

#print sifFiles
for sifFile in sifFiles:
	if not ".sif" in sifFile:
		print "Attempted to start with a non-sif file!"
		exit()

hostname = gethostname().split(".")[0].upper()
maxwell = [ "./Maxwell1D_x64", "-p", "sifFile", "-o", "ncFile" ]
cpu_count=multip.cpu_count()/2
pool = multip.Pool(processes=cpu_count)
print "Starting pool"
result = pool.map_async(maxwell_process, sifFiles)
print "Pool started"
pool.close()
pool.join()
print "Done"
