#!/usr/bin/python
# coding=utf-8

from math import *
import numpy as np
import matplotlib.pyplot as plt
import pylab as pylab
import matplotlib as mlab
import scipy as sp
import sys

n   = 9
t0  = radians(float(sys.argv[1]))
t0a  = radians(float(sys.argv[2]))
td  = radians(float(sys.argv[3]))
e1  = 1.01
e2  = 2.31
e3  = 1.01
pol = 'p'
r   = sqrt(e2-e1*sin(t0)**2)
s   = sqrt(e1)*sin(t0)
ra  = sqrt(e2-e1*sin(t0a)**2)
sa  = sqrt(e1)*sin(t0a)
dtdt=1
k   = 0.0; l = 0.0; u = 0.0;
if pol=='p':
	k = e1; l = e2; u = e3
elif pol=='s':
	k = 1.0; l = 1.0; u = 1.0
else:
	print 'ROFL'

def f(g, tt):
	if g < (r*s - sqrt(e3*(e2-e3)))/(r**2-e3):
		return 0.0
	if g > (r*s + sqrt(e3*(e2-e3)))/(r**2-e3):
		return 0.0
	# if abs(tt) > radians(40):
	# 	return 0.0
	grms = g*r-s
	rpgs = r+g*s
	eng2 = 1.0+g**2
	brok = 1.0/eng2
	rotTegn = eng2*e3-grms**2
	if (rotTegn < 0.0):
		return 0.0
		# print rotTegn
	rotTegn = sqrt(rotTegn)
	storSak = grms**2+rpgs*rotTegn

	prefactor    = (l*sqrt(e1)*cos(t0)+k*r)**2*u/(16.0*l**2*sqrt(e1)*cos(t0)*k)
	factor1      = abs(brok*(g*grms+rotTegn)-r)**3
	factor2over  = ((e2-l*e3/u)+(l/u-1.0)*brok*storSak)**2
	factor2under = ((brok*storSak-0.5*(e2+e3))**2-0.25*(e2-e3)**2)**2
	res = 1.0
	res *= prefactor
	res *= factor1
	res *= factor2over
	res /= factor2under
	res *= dTdt(g)
	# res *= dTdt2(tt)
	return res

def dTdt(g):
	grms = g*r-s
	rgps = r+g*s
	eng2 = 1.0+g**2
	rotTegn = eng2*e3-grms**2
	if (rotTegn < 0.0):
		return 0.0
		print rotTegn
	rotTegn = sqrt(rotTegn)
	return (cos(td)/(sqrt(e3)*eng2)*(g*grms+rotTegn)+sin(td)/(sqrt(e3)*eng2)*(-grms+g*rotTegn))**n

def dTdt2(tt):
	if abs(tt) > td:
		return 0
	return 1

def gCalc(tt):
	return (sqrt(e3)*sin(tt) - sqrt(e1)*sin(t0)) / (sqrt(e3)*cos(tt)-sqrt(e2-e1*sin(t0)**2))

def sgn(x):
	if x > 0.0:
		return 1
	if x < 0.0:
		return -1
	return 0

def vcalc(t0, tt):
	return sgn(sqrt(e3)*cos(tt) - sqrt(e2-e1*sin(t0)**2))

def hcalc(t0, tt):
	P = sqrt(e3*(e2-e1*sin(t0)**2))*cos(tt)
	Q = sqrt(e1*e3)*sin(t0)*sin(tt)
	return sgn(e3**2 - P - Q)

def MDTC(tt):
	Pa = sqrt(e3*(e2-e1*sin(t0)**2))*cos(tt)
	Qa = sqrt(e1*e3)*sin(t0)*sin(tt)
	va = sqrt(e3)*cos(tt) - sqrt(e2-e1*sin(t0)**2)
	ha = e3**2 - Pa - Qa
	P = sqrt(e3*(e2-e1*sin(t0a)**2))*cos(tt)
	Q = sqrt(e1*e3)*sin(t0a)*sin(tt)
	v = sqrt(e3)*cos(tt) - sqrt(e2-e1*sin(t0a)**2)
	h = e3**2 - P - Q
	if sgn(v) != sgn(h):
		return 0.0
	alpha1 = sqrt(e1)*cos(t0a)
	alpha2 = sqrt(e2-e1*sin(t0a)**2)
	
	A = 2.0*l*alpha1/(l*alpha1 + k*alpha2)
	factor1 = 4.0*abs(A)**2/(sqrt(e1)*cos(t0a))
	factor2 = k/u
	factor3 = 1.0/abs(sqrt(e3)*cos(tt) - sqrt(e2-e1*sin(t0a)**2))**3


	factor4over = (((P + Q)-0.5*(e2+e3))**2 - 0.25*(e2-e3)**2)**2
	factor4under = ((e2-l/u*e3) + (l/u -1.0)*(P+Q))**2

	res = 1.0
	res *= factor1
	res *= factor2
	res *= factor3
	res *= factor4over
	res /= factor4under
	res *= f(gCalc(tt), tt)
	return res

N      = 5001
t      = sp.linspace(-pi/2.0, pi/2.0, N)
deltat = t[1]-t[0]
A1     = 0.0
A2     = 0.0

for i in range(N):
	A1 += deltat*cos(t[i]-td)**9
	A2 += deltat*dTdt2(t[i])

mdtc = np.zeros(N)
cos9 = np.zeros(N)
dtdt = np.zeros(N)
v = np.zeros(N)
h = np.zeros(N)
vh = np.zeros(N)

for i in range(N):
	mdtc[i] = MDTC(t[i])/A1
	cos9[i] = 1.2*cos(t[i]-td)**9
	print degrees(t[i]), mdtc[i]

plt.plot(t,mdtc)
plt.show()
